<?php
//JAKE_CPG_SITEMAP

include "connect.php";
require("sitemap1.class.php");


/* 
Google Sitemap generator for Coppermine Photo Gallery
Distributed by: Jake Russell, developer of TagBlitz.com (and the TagBlitz Plug-in for CPG)

Since I am helping you to get EVERY SINGLE PAGE of your gallery spidered by Google:
A link to one of the following sites would GREATLY appreciated and would
encourage me to release more extremely useful FREE scripts like this.

http://www.JakesJokes.com
http://www.FreeClipartFree.com
*/



// Configuration

// ***************************************************
// Purpose: Define maximum number of links per page
// ***************************************************
// Every time this sitemap is accessed, it builds itself again from scratch, so you'll always be up to date.
// This also means, however, that every time this sitemap is accessed, it will use CPU and RAM on your server.
// Therefore, you don't want it to have to build enormous pages every time it's accessed.
//
// Google can handle a sitemap index with up to 50,000 links, but since this is generated on the fly,
// 400 per page keeps your sitemap pages at a reasonable size so that your server doesn't slow down
// (or the script doesn't time out) when Google accesses your sitemap.
// If you -REALLY- want to edit this number, you can, but I don't recommend it.
// (I'm a Search Engine Optimization expert, so you might want to listed to me on this...)
$max_links_per_sitemap = "400";

// ***************************************************
// Purpose: Define whether your gallery is at the top of your site, or in a sub-folder
// ***************************************************
// "1" if gallery is at the top folder (the front page) of your site (ie - "http://www.site.com")
// "0" if gallery is in a sub-folder under your site (ie - "http://www.site.com/gallery/" or other sub-folder)
$is_gallery_at_root = "1";

// ***************************************************
// Purpose: Define your site's domain name
// ***************************************************
// Be sure to include "http://" at the beginning
// Format should look like "http://www.site.com" -- No trailing slash or "index.php", etc.
$the_site = "http://www.YOUR_SITE_HERE.com";

// ***************************************************
// Purpose: Define the relative location of your gallery
// ***************************************************
// Use the relative path from the domain ("/gallery/"), and NOT the server path ("?var/user/public_html/gallery/")
// Add slash at beginning -AND- end of path
// It should look like "/gallery/" or "/scripts/gallery/", etc.
// If yor gallery is at the root of your domain, you can ignore this setting.
$the_folder = "/YOUR_GALLERY_FOLDER_HERE/"; 

// ***************************************************
// Purpose: Define your database prefix
// ***************************************************
// Yes, it's the same value as when you set up when you installed Coppermine
// If you don't remember what it is, it's listed in the file "includes/config.inc.php"
// Coppermine uses a prefix in case you're running another script that uses the same table name (ie - "pictures")
// Example: If your albums are in "cpg140_albums", then you would enter "cpg140_" below
// Example: If your albums are in "gallery2_albums", then you would enter "gallery2" below
$cpgdb_prefix = "cpg140_" ;

// ***************************************************
// Purpose: Just some extra variable definitions so we can access the tables later.
// ***************************************************
// Normally, this will never need changed, but if you renamed your database tables from the default names
// then you may edit this section accordingly. Remember, this is just the second half of the table name
// and NOT the prefix part (ie - NOT this part: "cpg140_")
$albumsdef = "albums";
$picturesdef = "pictures";



// ***************************************************
// ***************************************************
// DO NOT EDIT ANYTHING BELOW HERE
// ***************************************************
// ***************************************************


// ***************************************************
// Purpose: Define the "real" URL of the gallery
// ***************************************************
// If your gallery is at the to root of your site, great. (http://www.site.com)
// Otherwise, we're adding the folder to the URL. (http://www.site.com/gallery/)
// 1 = Gallery is at root, 0 = gallery is in a sub-folder
if ( $is_gallery_at_root == 1 ) {
	$the_gallery = $the_site."/";
	//echo $the_gallery;
} else {
	$the_gallery = $the_site . $the_folder;
	//echo $the_gallery;
}

// ***************************************************
// Purpose: Define the database information so we can access the tables with their full names
// ***************************************************
$gallery_albums = $cpgdb_prefix . $albumsdef;
$gallery_pictures = $cpgdb_prefix . $picturesdef;



// ***************************************************
// Purpose: Create an instance of Sitemap class
// ***************************************************
$sitemap = new Sitemap;

$sitemap->filterJavaScript = true;
$sitemap->filterMailto = true;
$sitemap->filterExternalLinks = true;

if (!isset($_REQUEST['category'])) {
  	/* Generate Sitemap index file */


// ***************************************************
// Purpose: Manually add a link to 'normal' sitemap
// ***************************************************

	// ORIGINAL
	// $sitemap->add($the_gallery . 'gallery_sitemap_xml.php?category=index');
	$sitemap->add("$the_gallery" . "gallery_sitemap_xml.php?category=index");

// ***************************************************
// Purpose: Grab category links from the database
// ***************************************************
	$res = mysql_query("SELECT aid FROM $gallery_albums ORDER BY aid");
	while ($row = mysql_fetch_assoc($res)) {
	 	$res2 = mysql_query("SELECT COUNT(*) FROM $gallery_pictures WHERE aid =$row[aid]");
		// $res2 = mysql_query('SELECT COUNT(*) FROM $gallery_pictures WHERE aid = $row['aid']');
	 	$count = mysql_result($res2, 0, 0);

// ***************************************************
// Purpose: Calculate the number of sitemaps this category will take
// ***************************************************
// We need to determine this since we're only using 400 links per sitemap page by default
// Therefore, a category or album with more than 400 items will likely need to be paginated
                $pages = ceil($count / $max_links_per_sitemap);

// ***************************************************
// Purpose: Add a link to the sitemap(s)
// ***************************************************
        	for($i=1; $i<=$pages; $i++) {
        		$sitemap->add("$the_gallery" . "gallery_sitemap_xml.php?category=".$row['aid']."&page=$i");
		}
	}

// ***************************************************
// Purpose: Generate the sitemap XML code
// ***************************************************
	$sitemap->XML_header();
	echo $sitemap->generateSitemapIndex();

}
else {
	$category = mysql_escape_string($_REQUEST['category']);

	if ($category == 'index') {
 		/* Generating 'normal' sitemap */


// ***************************************************
// Purpose: Manually add a page to the sitemap
// ***************************************************
		
		$sitemap->add($the_site, 'Home');

// ***************************************************
// Purpose: Download a page and grab all links from it
// ***************************************************
		$sitemap->index("$the_gallery"."index.php");

// ***************************************************
// Purpose: Filter out links that contain the following strings in URL
// ***************************************************
// This is mostly for security, as we obviously don't want sensitive pages listed in search engines
		
		$sitemap->filter('/admin/');
		$sitemap->filter('admin/');
		$sitemap->filter('admin.php');
		$sitemap->filter('config');
		$sitemap->filter('bridge');
		$sitemap->filter('upload');
		$sitemap->filter('upgrade');
		$sitemap->filter('update');
		$sitemap->filter('index.php');
		$sitemap->filter('xp_publish.log');
		$sitemap->filter('log');
		$sitemap->filter('.log');
		$sitemap->filter('.conf');
		$sitemap->filter('.conf.php');
		$sitemap->filter('.class');
		$sitemap->filter('.class.php');
		$sitemap->filter('search');
		$sitemap->filter('.inc');
		$sitemap->filter('.inc.php');
		$sitemap->filter('version');
		$sitemap->filter('install');
		$sitemap->filter('review');
		$sitemap->filter('report');
		$sitemap->filter('server');
		$sitemap->filter('relocate');
		$sitemap->filter('pluginmgr');
		$sitemap->filter('cgi-bin');
		$sitemap->filter('docs');
		$sitemap->filter('include');
		$sitemap->filter('lang');
		$sitemap->filter('util');
		$sitemap->filter('util');
		$sitemap->filter('plugin');
		$sitemap->filter('sql');
		$sitemap->filter('theme');
		$sitemap->filter('phpinfo');
		$sitemap->filter('picEditor');
		$sitemap->filter('picmgr');
		$sitemap->filter('keyword');
		$sitemap->filter('groupmgr');
		$sitemap->filter('getlang');
		$sitemap->filter('exif');
		$sitemap->filter('report');
		$sitemap->filter('delete');
		$sitemap->filter('db_');
		$sitemap->filter('mgr');
		$sitemap->filter(''); // links leading to main site

// ***************************************************
// Purpose: Finally, it's time to start building the sitemap XML code
// ***************************************************
		
		$sitemap->XML_header();
		echo $sitemap->generateSitemap();

	} else {
// ***************************************************
// Purpose: Generating category sitemap (The index of indexes, as Google calls it)
// ***************************************************
		$offset = ($_REQUEST['page']-1) * $max_links_per_sitemap;
		$limit = $max_links_per_sitemap;

// ***************************************************
// Purpose: Grab gallery media id's  from the database
// ***************************************************
// We're looking for Permanent URLs only, since the "normal" Coppermine URLs
// change every time you add, delete, or move a picture.
		$res = mysql_query("SELECT pid FROM $gallery_pictures WHERE aid =$category LIMIT $limit OFFSET $offset");
		while ($row = mysql_fetch_assoc($res)) {

// ***************************************************
// Purpose: Add a link to Permanent URL for specific media to the sitemap
// ***************************************************
			$sitemap->add($the_gallery . "displayimage.php?pos=-"  . $row['pid']);
		}
		
// ***************************************************
// Purpose: Generate the actual XML code for the sitemap
// ***************************************************
		$sitemap->XML_header();
		echo $sitemap->generateSitemap();
	}
}

?>
