<?php
// JAKE_CPG_SITEMAP

// DO NOT EDIT THIS FILE!!!!!
// (SERIOUSLY, I MEAN IT. DON'T MESS WITH A SINGLE THING IN THIS FILE.)


/**
 * @name sitemap.class.php
 * @version 2.0
 *
 * Distributed by: Jake Russell
 * A link to one of the following sites would GREATLY appreciated and would
 * encourage me to release more extremely useful FREE scripts like this.
 * 
 * http://www.JakesJokes.com
 * http://www.FreeClipartFree.com
 *
 * @desc
 * Sitemap generator class.
 *
 * Generates XML (Google Sitemap Protocol) sitemaps and sitemap
 * index files from remote website page or MySQL query from
 * local database.
 *
 * Can be used to return an array with values needed to
 * generate human-readable sitemaps.
 *
 * @package sitemap
 */

class Sitemap {

 	var $array = array();

        var $filterJavaScript = true;
        var $filterMailto = true;
        var $filterExternalLinks = true;

 	// fills the array with links from the page
 	function index( $url ) {
		$data = _urlOpen($url);

		preg_match_all('#<a\s+href\s*=\s*"(?P<url>[^"]+)".*?>(?P<title>.+?)</a>#i', $data, $matches, PREG_SET_ORDER);

		// remove tags from link titles
		$matches = array_map('cb_strip_tags', $matches);

		// filter blank lines
		$matches = array_filter($matches, 'cb_filter_blank');

		// fill the array
		while (list($i, $var) = each($matches)) {
		 	$this->array[] = array( 'url' => trim($var['url']),
		 				'title' => trim($var['title']),
		 				'data' => parse_url($var['url']),
		 				'index_url' => $url
		 				);

                // filter the results by setup
                if ($this->filterJavaScript == true)
			$this->array = array_filter($this->array, 'cb_filter_javascript');

                if ($this->filterMailto == true)
			$this->array = array_filter($this->array, 'cb_filter_mailto');

                if ($this->filterExternalLinks == true)
			$this->array = array_filter($this->array, 'cb_filter_external');

		// replace relative urls with absolute
		$this->array = array_map('cb_relative_paths', $this->array);

		}

	}

	function filter( $subject ) {
		while (list($i, $v) = each($this->array)) {
		 	if (strlen($subject) == 0) {
		 		if (!isset($v['data']['path']))
		 			unset($this->array[$i]);
			}
			else if (strpos($v['url'], $subject) > 0)
				unset($this->array[$i]);
		}
		reset($this->array);
	}

	function add( $url, $title = null ) {
                if ($title == null) {
                 	$title = $url;
		}

	 	$this->array[] = array( 'url' => $url,
	 				'title' => $title,
	 				'data' => parse_url($url)
	 				);
	}

	function query( $query, $dblink = null ) {
	 	if ($dblink == null) {
			$res = mysql_query( $query );
		} else {
		 	$res = mysql_query( $query, $dblink );
		}

		if ($res) {
			while ($row = mysql_fetch_assoc($res)) {
			 	if (!isset($row['url']))
			 		continue;

				if (!isset($row['title'])) {
				 	$row['title'] = $row['url'];
				}

				$this->array[] = array( 'url' => $row['url'],
		 				'title' => $row['title'],
		 				'data' => parse_url($row['url'])
		 				);
			}
		} else die(mysql_error());
	}

	function XML_header() {
	 	header("Content-Type: text/xml\n\n");
	}

	function generateSitemap() {
        	$xml = '';

		$xml .= "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n";
                $xml .= "<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\r\n";
                //$xml .= "<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.google.com/schemas/sitemap/0.84 http://www.google.com/schemas/sitemap/0.84/sitemap.xsd\">\r\n";

                foreach ($this->array as $item) {
                	$xml .= " <url>\r\n";
                	$xml .= "  <loc>" . htmlentities($item['url']) . "</loc>\r\n";
                	$xml .= " </url>\r\n";
		}

		$xml .= "</urlset>";

		return $xml;
	}

	function generateSitemapIndex() {
	 	$xml = '';

		$xml .= "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n";
                $xml .= "<sitemapindex xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\r\n";

                foreach ($this->array as $item) {
                	$xml .= " <sitemap>\r\n";
                	$xml .= "  <loc>" . htmlentities($item['url']) . "</loc>\r\n";
                	$xml .= " </sitemap>\r\n";
		}

		$xml .= "</sitemapindex>";

		return $xml;
	}

}

function _urlOpen( $url ) {
        // Fake the browser type
	ini_set('user_agent','MSIE 4\.0b2;');

	$dh = fopen("$url",'r');
	$contents = '';
	while (!feof($dh)) {
		$contents .= fread($dh, 8192);
	}
	fclose($dh);

	return $contents;
}

function cb_strip_tags( $var ) {
 	$var['url'] = strip_tags($var['url']);
 	$var['title'] = trim(strip_tags($var['title']));

	return $var;
}
function cb_relative_paths( $var ) {
 	if (!isset($var['data']['host'])) {
	 	$index_url_data = parse_url($var['index_url']);
	 	$index_schema_host = $index_url_data['scheme'] . '://' . $index_url_data['host'];
		$absolute_url = $index_schema_host . '/' . $var['data']['path'] . '?' . $var['data']['query'];

		$var['url'] = $absolute_url;
	}

	// remove PHPSESSID query strings
	$var['url'] = preg_replace('#(\?|&)PHPSESSID=([^&]+)#', '', $var['url']);

 	return $var;
}
function cb_filter_blank( $var ) {
 	return strlen($var['url']) > 0 and
 	       strlen($var['title']) > 0;
}
function cb_filter_javascript( $var ) {
 	return strpos($var['url'], 'javascript:') !== 0;
}
function cb_filter_mailto( $var ) {
 	return strpos($var['url'], 'mailto:') !== 0;
}
function cb_filter_external( $var ) {
 	if (isset($var['index_url'])) {
 		$index_url_data = parse_url($var['index_url']);
 		$index_host = $index_url_data['host'];
 		return (!isset($var['data']['host']) or (strcasecmp($var['data']['host'], $index_host)) == 0);
	} else {
	 	return true;
	}
}
?>
